Subject: Re: bug#47408: Etags support for Mercury [v0.3]

From: Eli Zaretskii <[email-masked]>
Date: Sun, 28 Mar 2021 19:22:15 +0300

> From: fabrice nicol <[email-masked]>
> Date: Sun, 28 Mar 2021 17:49:20 +0200
> 
> I left this couple of options in (following Francesco Potorti only for long options --declarations/--no-defines),
> for two reasons:
> 
> 1. The ambiguity between Objective C and Mercury
> 
> Both languages having the same file extension .m, it was necessary to add in a heuristic test function, in the
> absence of explicit language identification input from command line. 
> 
> Yet all heuristics may fail in rare cases. Tests show a fairly low failure rate on the Mercury compiler source
> code.  Less than 0.5 % of .m files are not identified as Mercury files by the test (this should have been
> documented somewhere).  File concerned by test failure are some Mercury test files and documentary test
> files with only (or almost only) comments and blank lines. 
> 
> While this could be improved by tweaking the heuristic test, it would make it more complex, bug-prone and
> ultimately hard to maintain.
> 
> So -m/-M are useful to deal with these rare files, as they do not rely on the heuristic test function at all but on
> their own semantics, which explicitly identifies Mercury.    
> 
> The only alternative I see is to explicitly warn users about adding '-l mercury' to command line when using
> long options (in etags.1 and possibly other docs). 

I think "-l mercury" is indeed the way to tell etags this is a Mercury
source.

We never had language-specific options in etags, and I don't see a
serious enough reason to introduce them now.  I do find it unfortunate
that Mercury uses the same extension as ObjC, but that's water under
the bridge.

Of course, if the heuristic test could be improved to make it err
less, it would also be good.

>  diff --git a/lisp/speedbar.el b/lisp/speedbar.el
> index 12e57b1108..63f3cd6ca1 100644
> --- a/lisp/speedbar.el
> +++ b/lisp/speedbar.el
> @@ -3534,6 +3534,8 @@ speedbar-fetch-etags-parse-list
>       speedbar-parse-c-or-c++tag)
>      ("^\\.emacs$\\|.\\(el\\|l\\|lsp\\)\\'" .
>       "def[^i]+\\s-+\\(\\(\\w\\|[-_]\\)+\\)\\s-*\C-?")
> +      ("^\\.m$\\'" .
> +     "\\(^:-\\)?\\s-*\\(\\(pred\\|func\\|type\\|instance\\|typeclass\\)+\\s+\\([a-z]+[a-zA-Z0-9_]*\\)+\\)\\s-*(?^?")
>  ;    ("\\.\\([fF]\\|for\\|FOR\\|77\\|90\\)\\'" .
>  ;      speedbar-parse-fortran77-tag)
>      ("\\.tex\\'" . speedbar-parse-tex-string)
> 
>  What about ObjC here? or are these keywords good for ObjC as well?
> 
> has the following reply: Objective C .m files are not parsed by speedbar.el in current repository code, so the
> added feature does not break anything.  Issues will only arise if/when Emacs maintainers for Objective C
> support decide on adding this file format to the speedbar parser.   It would be premature (and out-of-place)
> for me to settle this on my own.  Should this move happen, the heuristics used in etags.c (function
> test_objc_is_mercury) could then be ported to elisp code. 

OK, so please add there a comment to say that .m is also Objective C,
but Speedbar doesn't support it yet.

Thanks.